//+------------------------------------------------------------------+
//|                                       Hull moving average for ea |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2

//
//
//
//
//

extern int HMAPeriod = 15;
extern int HMAPrice  = PRICE_CLOSE;
extern int HMAMethod = MODE_LWMA;

//
//
//
//
//

double trend[];
double buffer1[];
double buffer2[];
int HalfPeriod;
int HullPeriod;

//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   HMAPeriod  = MathMax(2,HMAPeriod);
   HalfPeriod = MathFloor(HMAPeriod/2);
   HullPeriod = MathFloor(MathSqrt(HMAPeriod));
      IndicatorBuffers(3);
         SetIndexBuffer(0,trend);
         SetIndexBuffer(1,buffer1);
         SetIndexBuffer(2,buffer2);
   IndicatorShortName("HMA for EA ("+HMAPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;   
           limit=MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //
              
   for(i=limit; i>=0; i--) buffer1[i] = iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)*2.0-iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--)
   {
      buffer1[i] = iMAOnArray(buffer1,0,HullPeriod,0,HMAMethod,i);
      trend[i] = trend[i+1];
         if (buffer1[i] > buffer1[i+1]) trend[i]=  1;
         if (buffer1[i] < buffer1[i+1]) trend[i]= -1;
   }
   return(0);
}

   